10 REM A BASIC ADVENTURE WRITTEN BY PETER DASSOW
20 REM AS AN EXAMPLE HOW TO WRITE SUCH A GAME
30 REM PLEASE VISIT WWW.Z80.EU AND IT'S BLOG
40 REM YOU CAN COPY OR MODIFY THIS PROGRAM LIKE YOU WANT,
50 REM BUT IF YOU MODIFY THIS PROGRAM, YOU HAVE TO MENTION ALWAYS
60 REM WHO WROTES THE ORIGINAL PROGRAM AND WHERE IT CAME FROM.
70 REM THANK YOU FOR RESPECTING MY INTELLECTUAL WORK.
80 REM
90 FOR I%=1 TO 15:PRINT:NEXT I%
100 PRINT "   ___     _            _"
110 PRINT "  / _ \___| |_ ___ _ __( )__"
120 PRINT " / /_)/ _ \ __/ _ \ '__|/ __|"
130 PRINT "/ ___/  __/ ||  __/ |   \__ \"
140 PRINT "\/    \___|\__\___|_|   |___/"
150 PRINT
160 PRINT "   _       _                 _"
170 PRINT "  /_\   __| |_   _____ _ __ | |_ _   _ _ __ ___"
180 PRINT " //_\\ / _` \ \ / / _ \ '_ \| __| | | | '__/ _ \"
190 PRINT "/  _  \ (_| |\ V /  __/ | | | |_| |_| | | |  __/"
200 PRINT "\_/ \_/\__,_| \_/ \___|_| |_|\__|\__,_|_|  \___|  V1.02"
210 PRINT
220 PRINT "Type in commands. A full list of commands can be shown with 'HELP'."
230 OPTION BASE 1
240 REM RANDOMIZE TIMER for later extensions only needed
250 DIM WORDS$(15),WAY$(6),SHOWCMD$(2),PARAM$(3),ITEMDESC$(10),WHAT$(12)
260 DIM INVENTORY$(10),INVTYPE$(10)
270 DIM MAP$(11,11)
280 MX%=11:MY%=11:REM MAXIMUM SIZE OF MAP, MUST CORRELATE WITH DIM MAP$ ABOVE !
290 STEPS%=0:REM INITIAL SUM OF STEPS
300 HEALTH%=20:REM INITIAL MAX HEALTH VALUE
310 MHEALTH%=20:REM INITIAL MONSTER HEALTH (ALL TYPES)
320 GATHERED%=0:REM INITIAL MUMBER OF ITEMS IN INVENTORY
330 MINV%=20:REM MAXIMUM ITEMS IN INVENTORY
340 FOR I%=1 TO 15:READ WORDS$(I%):NEXT I%
350 FOR I%=1 TO 6:READ WAY$(I%):NEXT I%
360 FOR I%=1 TO 2:READ SHOWCMD$(I%):NEXT I%
370 FOR I%=1 TO 10:READ ITEMDESC$(I%):NEXT I%
380 REM SETUP FOR ROOMS ON THE MAP
390 FOR X%=1 TO MX%:FOR Y%=1 TO MY%
400 READ MAP$(X%,Y%)
410 NEXT Y%:NEXT X%
420 YMAP%=2:XMAP%=3:REM START COORDINATES
430 REM MAIN INTERPRETER LOOP STARTS HERE:
440 GOSUB 3430:REM INPUT WORDS
450 IF HEALTH%<10 AND HEALTH%>0 THEN PRINT "You're not in best shape. Eat something. Prevent to be hurt."
460 IF HEALTH%<1 THEN PRINT "You're now dead. You had better eat something. Game ends.":PRINT:RESTORE:PRINT "Restart.":GOTO 280
470 GOSUB 3540:REM UPPERCASE
480 GOSUB 3340:REM SPLIT INTO SINGLE WORDS
490 REM DEBUG ONLY:
500 REM FOR I%=1 TO CW%
510 REM PRINT I%;":";PARAM$(I%);"."
520 REM NEXT I%
530 I%=1:VERB%=0
540 WHILE I%<=15
550 IF PARAM$(1)=WORDS$(I%) THEN VERB%=I%
560 I%=I%+1
570 WEND
580 IF VERB%=0 THEN PRINT "Don't know how to do this: ";CMD$:GOTO 440
590 REM WE KNOW THE COMMAND (AT LEAST THE FIRST WORD)
600 IF VERB%<>1 THEN 630
610 PRINT "Commands are:";:FOR I%=1 TO 10:PRINT " '";WORDS$(I%);"'";:NEXT I%:FOR I%=1 TO 2:PRINT " '";WORDS$(10);" ";SHOWCMD$(I%);"'";:NEXT I%
620 FOR I%=11 TO 15:PRINT " '";WORDS$(I%);"'";:NEXT I%:PRINT:GOTO 440
630 IF VERB%<>15 THEN 700
640 REM * COMMAND QUIT *
650 PRINT "Are you sure (Y/N)? ";
660 KY$=INKEY$:WHILE KY$="":KY$=INKEY$:WEND
670 PRINT KY$
680 IF KY$="y" OR KY$="Y" THEN GOSUB 4070: PRINT "Ok. Goodbye.":END
690 IF KY$<>"n" AND KY$<>"N" THEN PRINT "What ?":GOTO 650
700 GOSUB 3600:GOSUB 4090:REM *** CHECK IF THERE IS SOMETHING HOSTILE ***
710 IF VERB%<>2 THEN 850
720 REM * COMMAND LOOK *
730 REM GOSUB 2970
740 REM TP%+1 contains number of map field items beginning from 1
750 REM Remember: Every second field item is NOT the word itself, instead the kind of item
760 FLIP%=0
770 FOR I%=1 TO TP%+1
780 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
790 IF FLIP%=1 THEN GOTO 830:REM Just the item name is not enough here, need to know if it's type 0
800 IF WHAT$(I%)="0" THEN PRINT "You see ";WHAT$(I%-1);"."
810 IF WHAT$(I%)="8" THEN PRINT "A ";WHAT$(I%-1);" attacks you."
820 IF WHAT$(I%)="9" THEN PRINT "A ";WHAT$(I%-1);" is waiting."
830 NEXT I%
840 GOTO 3300
850 IF VERB%<>3 AND VERB%<>4 THEN 1180
860 REM * COMMAND TAKE & GET *
870 REM
880 REM GOSUB 2970
890 REM TP%+1 contains number of map field items beginning from 1
900 REM Remember: Every second field item is NOT the word itself, instead the kind of item
910 FLIP%=0:TAKEN%=0
920 FOR I%=1 TO TP%+1
930 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
940 IF FLIP%=0 THEN 1100:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
950 J%=I%:CMD$=WHAT$(I%):GOSUB 3540:I%=J%:REM You must save I% before using the subroutine
960 IF PARAM$(2)<>CMD$ THEN 1100
970 IF WHAT$(I%+1)="0" OR WHAT$(I%+1)="8" OR WHAT$(I%+1)="9" OR WHAT$(I%+1)="10" THEN PRINT "This can't be taken.":I%=TP%+1:GOTO 1100
980 IF GATHERED%>=MINV% THEN PRINT "Can't carry more.":I%=TP%+1:GOTO 1100
990 PRINT "Taken !":TAKEN%=I%
1000 GATHERED%=GATHERED%+1
1010 INVENTORY$(GATHERED%)=PARAM$(2):INVTYPE$(GATHERED%)=WHAT$(I%+1)
1020 IF WHAT$(I%+1)="1" THEN PRINT "But it's ";ITEMDESC$(1)
1030 IF WHAT$(I%+1)="2" THEN PRINT "It's ";ITEMDESC$(2)
1040 IF WHAT$(I%+1)="3" THEN PRINT "It's ";ITEMDESC$(3)
1050 IF WHAT$(I%+1)="4" THEN PRINT "It's ";ITEMDESC$(4)
1060 IF WHAT$(I%+1)="5" THEN PRINT "It's ";ITEMDESC$(5)
1070 IF WHAT$(I%+1)="6" THEN PRINT "It's ";ITEMDESC$(6)
1080 IF WHAT$(I%+1)="7" THEN PRINT "It's ";ITEMDESC$(7)
1090 I%=TP%+1:REM LET THE LOOP END
1100 NEXT I%
1110 IF TAKEN%<1 THEN PRINT "There is no item like this.":GOTO 3300
1120 REM Code here assumes an item is taken for sure
1130 IF TAKEN%>0 AND (INVTYPE$(GATHERED%)="5" OR INVTYPE$(GATHERED%)="3") THEN FOUND%=TAKEN%:GOSUB 3760
1140 REM
1150 REM
1160 GOTO 3300
1170 REM * COMMAND DROP *
1180 IF VERB%<>5 THEN 1320
1190 PRINT "I'll try to drop ";PARAM$(2)
1200 SUCCESS%=0
1210 FOR I%=1 TO GATHERED%
1220 IF INVENTORY$(I%)<>PARAM$(2) THEN 1280
1230 PRINT "Ok, dropped.":SUCCESS%=1
1240 FOR J%=I% TO GATHERED%-1
1250 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1260 NEXT J%
1270 I%=GATHERED%:GATHERED%=GATHERED%-1
1280 NEXT I%
1290 IF SUCCESS%=0 THEN PRINT "Couldn't drop it."
1300 GOTO 3300
1310 REM * COMMAND EAT *
1320 IF VERB%<>6 THEN 1490
1330 REM Without any parameter NOT useful
1340 IF CW%<=1 THEN PRINT "What should I eat ?":GOTO 3300
1350 PRINT "Try to eat ";PARAM$(2)
1360 SUCCESS%=0
1370 FOR I%=1 TO GATHERED%
1380 IF INVENTORY$(I%)<>PARAM$(2) THEN 1460
1390 IF INVTYPE$(I%)<>"4" THEN I%=GATHERED%:GOTO 1460
1400 PRINT "Ok, I eat that. Health increased.":SUCCESS%=1
1410 FOR J%=I% TO GATHERED%-1
1420 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1430 NEXT J%
1440 I%=GATHERED%:GATHERED%=GATHERED%-1
1450 HEALTH%=HEALTH%+3:IF HEALTH%>20 THEN HEALTH%=20
1460 NEXT I%
1470 IF SUCCESS%=0 THEN PRINT "Are you sure this can be eaten ?"
1480 GOTO 3300
1490 REM * COMMAND KILL *
1500 IF VERB%<>7 THEN 1830
1510 IF CW%<=1 THEN PRINT "What should I kill ?":GOTO 3300
1520 PRINT "Try to kill ";PARAM$(2)
1530 REM GOSUB 2970:REM TP%+1 contains number of map field items beginning from 1
1540 FLIP%=0:FOUND%=0
1550 FOR I%=1 TO TP%+1
1560 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
1570 IF FLIP%=0 THEN 1600:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
1580 IF WHAT$(I%+1)<>"8" THEN 1600:REM ONLY "8" IS SOMETHING HOSTILE
1590 CMD$=WHAT$(I%):J%=I%:GOSUB 3540:I%=J%:IF CMD$=PARAM$(2) THEN FOUND%=I%
1600 NEXT I%
1610 IF FOUND%=0 THEN PRINT "Nothing like this can be killed...":GOTO 1810
1620 SUCCESS%=0
1630 PRINT "Looking for a weapon in inventory now."
1640 FOR I%=1 TO GATHERED%
1650 REM Looking first for a weapon within inventory
1660 REM PRINT "DEBUG INVENTORY:";INVENTORY$(I%);",";INVTYPE$(I%)
1670 IF INVTYPE$(I%)<>"2" AND INVTYPE$(I%)<>"3" THEN 1760
1680 PRINT "Using ";INVENTORY$(I%);" ...":SUCCESS%=1
1690 IF INVTYPE$(I%)="3" THEN PRINT "A better weapon.":MHEALTH%=MHEALTH%-10:REM A WEAPON KILLS BETTER, SUBSTRACT MORE ;-)
1700 FOR J%=I% TO GATHERED%-1
1710 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
1720 NEXT J%
1730 I%=GATHERED%:GATHERED%=GATHERED%-1
1740 MHEALTH%=MHEALTH%-10:IF HEALTH%<1 THEN MHEALTH%=0
1750 IF MHEALTH%<1 THEN PRINT "You successfully killed ";PARAM$(2) ELSE PRINT "Still alive..."
1760 NEXT I%
1770 IF SUCCESS%=0 THEN PRINT "You have nothing which can be used as a weapon.":GOTO 1810
1780 IF MHEALTH%>0 THEN 1810
1790 GOSUB 3600:REM TP%+1 contains number of map field items beginning from 1
1800 GOSUB 3760
1810 REM KILL can be implemented more specific, but already usable
1820 GOTO 3300
1830 REM * COMMAND RUN & GO *
1840 IF VERB%<>8 AND VERB%<>9 THEN 2210
1850 REM Evaluate where to go
1860 DIRECT%=0:MHEALTH%=20:REM Monsters are always alive if a map tile reached
1870 FOR I%=1 TO 6
1880 IF PARAM$(2)=WAY$(I%) THEN DIRECT%=I%
1890 NEXT I%
1900 IF DIRECT%=0 THEN PRINT "Don't know where this is ... (try a geographic direction)":GOTO 3300
1910 REM
1920 OLDY%=YMAP%:OLDX%=XMAP%:REM PRINT "DEBUG: Remembering old coords OLDY%=";OLDY%;",OLDX%=";OLDX%
1930 IF DIRECT%=1 THEN YMAP%=YMAP%-1:REM NORTH
1940 IF DIRECT%=2 THEN XMAP%=XMAP%+1:REM EAST
1950 IF DIRECT%=3 THEN YMAP%=YMAP%+1:REM SOUTH
1960 IF DIRECT%=4 THEN XMAP%=XMAP%-1:REM WEST
1970 GOSUB 3600:REM TP%+1 contains number of map field items beginning from 1
1980 REM Remember: Every second field item is NOT the word itself, instead the kind of item
1990 FLIP%=0:BLOCKED%=0
2000 FOR I%=1 TO TP%+1
2010 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
2020 IF FLIP%=1 THEN GOTO 2040:REM Just the item name is not enough here, need to know if it's type 0
2030 IF WHAT$(I%)="99" THEN BLOCKED%=1:REM Type 99 item is BLOCK THIS MAP TILE
2040 NEXT I%
2050 REM PRINT "DEBUG: BLOCKED%=";BLOCKED%
2060 IF YMAP%<1 OR XMAP%<1 OR YMAP%>MY% OR XMAP%>MX% OR BLOCKED%=1 THEN YMAP%=OLDY%:XMAP%=OLDX%:PRINT "Can't go there." ELSE STEPS%=STEPS%+1
2070 REM PRINT "DEBUG: New coords YMAP%=";YMAP%;",XMAP%=";XMAP%;" OLDY%=";OLDY%;",OLDX%=";OLDX%
2080 GOSUB 3600:REM TP%+1 contains number of map field items beginning from 1
2090 REM Remember: Every second field item is NOT the word itself, instead the kind of item
2100 FLIP%=0
2110 FOR I%=1 TO TP%+1
2120 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
2130 IF FLIP%=1 THEN GOTO 2160:REM FLIP%==1 means 1st of 2 parameter, but we need the 2nd parameter (type)
2140 IF WHAT$(I%)="0" THEN PRINT "You see ";WHAT$(I%-1);"."
2150 IF WHAT$(I%)="8" THEN PRINT "A ";WHAT$(I%-1);" attacks you."
2160 NEXT I%
2170 PRINT "That was your step #";STEPS%
2180 HEALTH%=HEALTH%-1
2190 GOTO 3300
2200 REM * COMMAND SHOW *
2210 IF VERB%<>10 THEN 2560
2220 REM
2230 REM Show without parameter means show all items (if existing)
2240 REM
2250 IF CW%<=1 THEN 2290
2260 IF PARAM$(2)=SHOWCMD$(1) THEN GOSUB 3990:GOTO 3300
2270 IF PARAM$(2)=SHOWCMD$(2) THEN GOSUB 4040:GOTO 3300
2280 PRINT "Don't know to show """;PARAM$(2);"""":GOTO 3300
2290 REM GOSUB 2970:REM TP%+1 contains number of map field items beginning from 1
2300 REM Remember: Every second field item is NOT the word itself, instead the kind of item
2310 FLIP%=0
2320 FOR I%=1 TO TP%+1
2330 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
2340 IF FLIP%<>1 THEN 2420:REM If not the 1st parameter then look for 2nd parameter
2350 IF WHAT$(I%+1)="0" THEN 2520:REM skip parameter with descriptions
2360 REM PRINT "DEBUG: WHAT$(";I%;")=";WHAT$(I%);", WHAT$(";I%+1;")=";WHAT$(I%+1);"."
2370 IF I%>TP% THEN PRINT "ERROR IN MAP DATA. ITEM TYPE VALUE MISSING.":END
2380 IF WHAT$(I%+1)="8" OR WHAT$(I%+1)="9" THEN PRINT "A ";
2390 IF WHAT$(I%+1)<>"7" THEN PRINT WHAT$(I%);
2400 GOTO 2520
2410 REM The following lines can be optimized by using ITEMDESC$(VAL(WHAT$(I%)))
2420 IF WHAT$(I%)="1" THEN PRINT "  ... ";ITEMDESC$(1);"."
2430 IF WHAT$(I%)="2" THEN PRINT "  ... ";ITEMDESC$(2);"."
2440 IF WHAT$(I%)="3" THEN PRINT "  ... ";ITEMDESC$(3);"."
2450 IF WHAT$(I%)="4" THEN PRINT "  ... ";ITEMDESC$(4);"."
2460 IF WHAT$(I%)="5" THEN PRINT "  ... ";ITEMDESC$(5);"."
2470 IF WHAT$(I%)="6" THEN PRINT "  ... ";ITEMDESC$(6);"."
2480 REM IF WHAT$(I%)="7" THEN PRINT "  ... ";ITEMDESC$(7);".":REM A key should not be seen immediately
2490 IF WHAT$(I%)="8" THEN PRINT "  ... ";ITEMDESC$(8);"."
2500 IF WHAT$(I%)="9" THEN PRINT "  ... ";ITEMDESC$(9);"."
2510 IF WHAT$(I%)="10" THEN PRINT "  ... ";ITEMDESC$(10);"."
2520 NEXT I%
2530 REM
2540 GOTO 3300
2550 REM * COMMAND MAP *
2560 IF VERB%<>11 THEN 2660
2570 PRINT "Let me show your position on the map:"
2580 FOR I%=1 TO MX%
2590 FOR J%=1 TO MY%
2600 IF YMAP%=I% AND XMAP%=J% THEN PRINT " * "; ELSE PRINT " _ ";
2610 NEXT J%
2620 PRINT
2630 NEXT I%
2640 GOTO 3300
2650 REM * COMMAND DRINK *
2660 IF VERB%<>12 THEN 2870
2670 IF CW%<=1 THEN PRINT "What should I drink ?":GOTO 3300
2680 PRINT "Try to drink ";PARAM$(2)
2690 SUCCESS%=0
2700 FOR I%=1 TO GATHERED%
2710 IF INVENTORY$(I%)<>PARAM$(2) THEN 2790
2720 IF INVTYPE$(I%)<>"6" THEN I%=GATHERED%:GOTO 2790
2730 PRINT "Ok, I drink that. Health increased.":SUCCESS%=1
2740 FOR J%=I% TO GATHERED%-1
2750 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
2760 NEXT J%
2770 I%=GATHERED%:GATHERED%=GATHERED%-1
2780 HEALTH%=HEALTH%+2:IF HEALTH%>20 THEN HEALTH%=20
2790 NEXT I%
2800 IF SUCCESS%=0 THEN PRINT "Are you sure this is something to drink ?"
2810 GOTO 3300
2820 REM Not yet implemented to eval type 6 items
2830 HEALTH%=HEALTH%+1:IF HEALTH%>20 THEN HEALTH%=20
2840 REM Some coding here
2850 GOTO 3300
2860 REM
2870 IF VERB%<>13 THEN 3170
2880 REM * COMMAND GIVE *
2890 SUCCESS%=0
2900 FOR I%=1 TO TP%+1:IF WHAT$(I%)="9" THEN SUCCESS%=1
2910 NEXT I%:IF SUCCESS%=0 THEN PRINT "Nobody here who would take it.":GOTO 3300
2920 FOR I%=1 TO GATHERED%
2930 IF INVENTORY$(I%)<>PARAM$(2) THEN 3140
2940 IF INVTYPE$(I%)<>"5" THEN I%=GATHERED%:GOTO 3140
2950 PRINT "It's accepted as a payment.":SUCCESS%=1
2960 REM Now delete the given item from the inventory
2970 FOR J%=I% TO GATHERED%-1
2980 INVENTORY$(J%)=INVENTORY$(J%+1):INVTYPE$(J%)=INVTYPE$(J%+1)
2990 NEXT J%
3000 I%=GATHERED%:GATHERED%=GATHERED%-1
3010 REM Now take the new item
3020 FLIP%=0:TAKEN%=0
3030 FOR K%=1 TO TP%+1
3040 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
3050 IF FLIP%=0 THEN 3110:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
3060 IF WHAT$(K%+1)<>"7" THEN 3110
3070 IF GATHERED%>=MINV% THEN PRINT "Can't carry more.":K%=TP%+1:GOTO 3110
3080 GATHERED%=GATHERED%+1
3090 INVENTORY$(GATHERED%)=WHAT$(K%):INVTYPE$(GATHERED%)=WHAT$(K%+1)
3100 PRINT "You got ";WHAT$(K%);" !":TAKEN%=K%:K%=TP%+1
3110 NEXT K%
3120 IF TAKEN%>0 THEN FOUND%=TAKEN%:GOSUB 3760
3130 REM
3140 NEXT I%
3150 REM
3160 GOTO 3300
3170 IF VERB%<>14 THEN 3260
3180 SUCCESS%=0:FOR I%=1 TO TP%+1:IF WHAT$(I%)="10" THEN SUCCESS%=1
3190 NEXT I%:IF SUCCESS%=0 THEN PRINT "Nothing can be unlocked here.":GOTO 3260
3200 FOUND%=0:FOR I%=1 TO GATHERED%:IF INVTYPE$(I%)="7" THEN PRINT "Using ";INVENTORY$(I%);" for unlocking...":FOUND%=1
3210 NEXT I%
3220 IF FOUND%<>1 THEN GOTO 3300
3230 PRINT "You found the treasure.":PRINT
3240 PRINT "Congratulation ! You solved the mystery in ";STEPS%;" steps."
3250 END:REM This END statement can be replaced with a GOTO to the quit command
3260 REM - Do not delete this line (it's a GOTO target)
3270 REM
3280 REM Room for additional commands and the code for it
3290 REM
3300 GOTO 440:REM *** END OF MAIN INTERPRETER LOOP ***
3310 REM
3320 REM --- *** A lot of subroutines follow now! *** ---
3330 REM
3340 L%=LEN(CMD$):BW%=1
3350 CW%=1:REM START VALUE FOR NUMBER OF WORDS PER COMMAND
3360 FOR I%=1 TO L%
3370 IF MID$(CMD$,I%,1)<>" " THEN 3400
3380 PARAM$(CW%)=MID$(CMD$,BW%,I%-BW%):CW%=CW%+1:I%=I%+1:BW%=I%
3390 IF CW%>2 THEN I%=L%
3400 NEXT I%
3410 PARAM$(CW%)=MID$(CMD$,BW%,I%-BW%)
3420 RETURN
3430 REM SUBROUTINE INTERPRET COMMAND, ELIMINATING BLANKS
3440 INPUT "Command ";CMD$
3450 L%=LEN(CMD$):LK$="":NCMD$=""
3460 FOR I%=1 TO L%
3470 KY$=MID$(CMD$,I%,1)
3480 IF KY$=" " THEN IF LK$=" " THEN 3500
3490 NCMD$=NCMD$+KY$
3500 LK$=KY$
3510 NEXT I%
3520 CMD$=NCMD$
3530 RETURN
3540 REM SUBROUTINE UPCASE COMMAND
3550 FOR I%=1 TO LEN(CMD$)
3560 UC%=ASC(MID$(CMD$,I%,1)):IF UC%>96 AND UC%<123 THEN UC%=UC%-32
3570 MID$(CMD$,I%,1)=CHR$(UC%)
3580 NEXT I%
3590 RETURN
3600 REM SUBROUTINE SEPARATE ALL ITEMS OF MAP$ CONTENT AS SINGLE WORDS INTO WHAT$(INDEX)
3605 IF XMAP%>MX% OR YMAP%>MY% OR XMAP%<1 OR YMAP%<1 THEN ITEMS$="":GOTO 3750
3610 ITEMS$=MAP$(YMAP%,XMAP%)
3620 WP%=1:TP%=0
3630 L%=LEN(ITEMS$)
3640 FOR I%=1 TO L%
3650 IF MID$(ITEMS$,I%,1)<>"," THEN 3700
3660 TP%=TP%+1
3670 IF TP%>1 THEN NWORD$=MID$(ITEMS$,WP%+1,I%-WP%-1) ELSE NWORD$=MID$(ITEMS$,WP%,I%-WP%)
3680 WP%=I%
3690 WHAT$(TP%)=NWORD$
3700 NEXT I%
3710 IF TP%>=1 THEN WP%=WP%+1
3720 NWORD$=MID$(ITEMS$,WP%,I%-WP%+1)
3730 WHAT$(TP%+1)=NWORD$
3740 IF TP%+1<2 THEN PRINT "ERROR IN MAP TABLE DATA. NOT ENOUGH PARAMETER PER FIELD !":END
3750 RETURN
3760 REM SUBROUTINE DELETE ONE ITEM IN MAP$(INDEX), DEPENDING ON PARAMETER FOUND%
3770 DITEM%=0:FLIP%=0:REM PRINT "DEBUG: FOUND%=";FOUND%
3780 FOR I%=1 TO TP%+1
3790 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
3800 IF FLIP%=1 THEN 3880:REM skip 1st parameter
3810 REM FLIP%=0 STARTS HERE
3820 REM PRINT "DEBUG: WHAT$(";I%;")=";WHAT$(I%)
3830 IF WHAT$(I%)<>"8" AND WHAT$(I%)<>"5" AND WHAT$(I%)<>"3" AND WHAT$(I%)<>"7" THEN 3880:REM IF NOT POSSIBLE TO DELETE, SKIP
3840 REM PRINT "DEBUG: FOUND%=";FOUND%;" was I%-1=";I%-1;" ?"
3850 IF FOUND%<>I%-1 THEN 3880
3860 REM PRINT "DEBUG: Have to delete the item ";FOUND%;" in the map field."
3870 DITEM%=FOUND%
3880 NEXT I%
3890 IF DITEM%=0 THEN 3980
3900 ITEMS$=""
3910 FOR I%=1 TO TP%+1
3920 IF DITEM%=I% THEN I%=I%+1:GOTO 3940:REM SKIP 2 ITEMS IN LIST
3930 ITEMS$=ITEMS$+WHAT$(I%)+","
3940 NEXT I%
3950 IF RIGHT$(ITEMS$,1)="," THEN ITEMS$=LEFT$(ITEMS$,LEN(ITEMS$)-1)
3960 MAP$(YMAP%,XMAP%)=ITEMS$:REM PRINT "DEBUG: ITEMS$()=";ITEMS$
3970 REM
3980 RETURN
3990 REM SUBROUTINE SHOW INVENTORY
4000 FOR I%=1 TO GATHERED%
4010 PRINT INVENTORY$(I%);" (";ITEMDESC$(VAL(INVTYPE$(I%)));")"
4020 NEXT I%
4030 RETURN
4040 REM SUBROUTINE SHOW STATUS
4050 PRINT "Health:";HEALTH%*5!;"%"
4060 PRINT "Free inventory slots:";MINV%-GATHERED%
4070 PRINT "Steps already taken:";STEPS%:REM Entry point here for QUIT command
4080 RETURN
4090 REM SUBROUTINE CHECK if something is hostile here
4100 FLIP%=0:FOUND%=0
4110 FOR I%=1 TO TP%+1
4120 IF FLIP%=1 THEN FLIP%=0 ELSE FLIP%=1
4130 IF FLIP%=0 THEN 4160:REM NOT THE FIELD CONTENT WE NEED TO COMPARE
4140 IF WHAT$(I%+1)<>"8" THEN 4160:REM ONLY "8" IS SOMETHING HOSTILE
4150 FOUND%=I%
4160 NEXT I%
4170 IF FOUND%=0 THEN 4210
4180 HEALTH%=HEALTH%-5:REM FROM 20 TAKE 5 (25%)
4190 PRINT "You were hurt !!!"
4200 IF HEALTH%<0 THEN HEALTH%=0
4210 RETURN
4220 REM 15 COMMAND KEYWORDS
4230 DATA "HELP","LOOK","TAKE","GET","DROP","EAT","KILL","RUN","GO"
4240 DATA "SHOW","MAP","DRINK","GIVE","UNLOCK","QUIT"
4250 REM 6 COMMAND PARAMETER FOR GO,RUN AND LOOK
4260 DATA "NORTH","EAST","SOUTH","WEST","UP","DOWN"
4270 REM 2 COMMAND PARAMETER FOR SHOW
4280 DATA "INVENTORY","STATUS"
4290 REM 9 ITEM TYPE DESCRIPTIONS
4300 DATA "nothing special"
4310 DATA "may be an item to hurt something"
4320 DATA "may be an item to kill something for sure"
4330 DATA "may be something to eat"
4340 DATA "may be helpful for paying something"
4350 DATA "may be something to drink"
4360 DATA "may be to unlock something"
4370 DATA "hostile"
4380 DATA "may be you can something buy here"
4390 DATA "a surprise is waiting for you"
4400 REM 
4410 REM MAP CONTENT (A HORIZONTAL LINE HAVE 11 TILES), 11 MAP LINES IN TOTAL
4420 REM
4430 REM First paramter is always an object name or description, second the item type
4440 REM Item type 0 = Description (displayed with LOOK)
4450 REM Item type 1 = An item nothing special (you can't do anything with it)
4460 REM Item type 2 = An item which can be used to hurt something
4470 REM Item type 3 = An item which can be used to kill something
4480 REM Item type 4 = An item which can be eat
4490 REM Item type 5 = An item which can be used to pay something
4500 REM Item type 6 = An item which can be drink
4510 REM Item type 7 = An item which is given from a merchant to unlock something
4520 REM Item type 8 = A hostile object/creature/person
4530 REM Item type 9 = A merchant's description
4540 REM Item type 10 = A chest or something else you can unlock (game ends)
4550 REM Item type 99 = A blocked map tile (from all directions)
4560 REM
4570 REM 1
4580 DATA "Grass,1,the border,0"
4590 DATA "Plants,1,the border,0"
4600 DATA "Grass,1,the border,0"
4610 DATA "Grass,1,Plants,1,the border,0"
4620 DATA "Grass,1,the border,0"
4630 DATA "Grass,1,Plants,1,the border,0"
4640 DATA "Grass,1,the border and small fountain of water,0,Water,6"
4650 DATA "Grass,1,the border,0"
4660 DATA "Grass,1,the border,0"
4670 DATA "Grass,1,the border,0"
4680 DATA "Grass,1,the border,0"
4690 REM 2
4700 DATA "Grass,1,the border,0"
4710 DATA "Grass,1,grassland,0"
4720 DATA "Grass,1,Stones,2,Plants,1,stony ground,0"
4730 DATA "Grass,1,Stones,2,grassland with stones,0"
4740 DATA "Grass,1,Insects,1,grassland and a small fountain,0,Water,6"
4750 DATA "Blocked,99"
4760 DATA "Grass,1,Trees,1,Nuts,4,a forest,0"
4770 DATA "Grass,1,Trees,1,Nuts,4,a forest,0"
4780 DATA "Grass,1,Trees,1,Nuts,4,Stones,2,a forest and stones,0"
4790 DATA "Grass,1,Stones,2,Gold,5,stony grassland,0"
4800 DATA "Grass,1,Stones,2,Gold,5,the border and stony grassland,0"
4810 REM 3
4820 DATA "Grass,1,the border,0"
4830 DATA "Grass,1,grassland,0"
4840 DATA "Grass,1,grassland,0"
4850 DATA "Knife,3,a place,0,grass,1,some grass,0"
4860 DATA "Grass,1,Insects,1,grassland,0"
4870 DATA "Grass,1,Berries,4,grass and bushes,0"
4880 DATA "Grass,1,Berries,4,grass and bushes,0"
4890 DATA "Grass,1,Berries,4,grass and bushes,0"
4900 DATA "Grass,1,Trees,1,Apple,4,a forest,0"
4910 DATA "Grass,1,Bush,1,Berries,4,grassland and a bush,0"
4920 DATA "Grass,1,the border and grassland,0"
4930 REM 4
4940 DATA "Grass,1,the border,0"
4950 DATA "Grass,1,grassland,0"
4960 DATA "Rocks,3,stony ground,0"
4970 DATA "Stones,2,stony ground,0"
4980 DATA "Grass,1,grassland,0"
4990 DATA "Grass,1,grassland,0"
5000 DATA "Grass,1,grassland,0"
5010 DATA "Grass,1,Bush,1,Berries,4,bushes and a few trees,0"
5020 DATA "Grass,1,grassland,0"
5030 DATA "Grass,1,grassland,0"
5040 DATA "Grass,1,the border,0"
5050 REM 5
5060 DATA "Grass,1,the border,0"
5070 DATA "Grass,1,grassland,0"
5080 DATA "Rocks,3,stony ground,0"
5090 DATA "Grass,1,man,8,a house and around grass,0"
5100 DATA "Grass,1,grassland,0"
5110 DATA "Grass,1,grassland,0"
5120 DATA "Grass,1,grassland,0"
5130 DATA "Water,6,a small lake,0"
5140 DATA "Grass,1,grassland,0"
5150 DATA "Grass,1,grassland,0"
5160 DATA "Grass,1,the border,0"
5170 REM 6
5180 DATA "Grass,1,the border,0"
5190 DATA "Grass,1,grassland,0"
5200 DATA "Rocks,3,stony ground,0"
5210 DATA "Grass,1,Wood,2,Chocolate,4,a fence and much grass,0"
5220 DATA "Grass,1,grassland,0"
5230 DATA "Grass,1,Sword,3,grassland,0"
5240 DATA "Grass,1,Gold,5,grassland,0"
5250 DATA "Grass,1,Leafes,1,monster,8,grassland with bushes,0"
5260 DATA "Grass,1,grassland and a tent with a merchant,0,Key,7,merchant,9"
5270 DATA "Grass,1,grassland,0"
5280 DATA "Grass,1,the border,0"
5290 REM 7
5300 DATA "Grass,1,the border,0"
5310 DATA "Grass,1,grassland,0"
5320 DATA "Rocks,3,stony ground,0"
5330 DATA "Grass,1,grassland,0"
5340 DATA "Grass,1,grassland,0"
5350 DATA "Grass,1,a farmer with cows and a milk can,0,Milk,6"
5360 DATA "Grass,1,grassland,0"
5370 DATA "Grass,1,grassland,0,Sword,3"
5380 DATA "Grass,1,grassland and a small hut,0,Chest,10"
5390 DATA "Grass,1,grassland,0"
5400 DATA "Grass,1,the border,0"
5410 REM 8
5420 DATA "Grass,1,the border,0"
5430 DATA "Grass,1,grassland,0"
5440 DATA "Rocks,3,stony ground,0"
5450 DATA "Grass,1,grassland and an apple tree,0,Apple,4"
5460 DATA "Grass,1,grassland,0"
5470 DATA "Grass,1,grassland,0"
5480 DATA "Grass,1,grassland and a fountain,0,Water,6"
5490 DATA "Grass,1,grassland,0"
5500 DATA "Grass,1,grassland,0"
5510 DATA "Grass,1,grassland,0"
5520 DATA "Grass,1,the border,0"
5530 REM 9
5540 DATA "Grass,1,the border,0"
5550 DATA "Grass,1,grassland,0"
5560 DATA "Rocks,3,stony ground,0"
5570 DATA "Grass,1,grassland,0"
5580 DATA "Grass,1,grassland,0"
5590 DATA "Grass,1,grassland,0"
5600 DATA "Grass,1,grassland,0,Wood,3"
5610 DATA "Grass,1,grassland,0"
5620 DATA "Grass,1,grassland,0"
5630 DATA "Grass,1,grassland,0"
5640 DATA "Grass,1,the border,0"
5650 REM 10
5660 DATA "Grass,1,the border,0"
5670 DATA "Grass,1,grassland,0"
5680 DATA "Rocks,3,stony ground,0"
5690 DATA "Grass,1,grassland,0"
5700 DATA "Grass,1,grassland,0"
5710 DATA "Grass,1,grassland,0"
5720 DATA "Grass,1,grassland and apple trees,0,Apple,4"
5730 DATA "Grass,1,grassland,0"
5740 DATA "Grass,1,grassland,0"
5750 DATA "Grass,1,grassland,0"
5760 DATA "Grass,1,the border,0"
5770 REM 11
5780 DATA "Grass,1,the border,0"
5790 DATA "Grass,1,the border,0"
5800 DATA "Rocks,3,the border,0,Gold,5"
5810 DATA "Grass,1,the border and some creatures,0,creature,8"
5820 DATA "Grass,1,the border,0"
5830 DATA "Grass,1,the border and a fountain,0,Water,6"
5840 DATA "Grass,1,the border,0"
5850 DATA "Stones,2,the border,0"
5860 DATA "Grass,1,the border,0"
5870 DATA "Grass,1,the border,0"
5880 DATA "Grass,1,the border,0"
